Index: /branches/UKMO/AMM15_v3_6_STABLE_package_FABM/NEMOGCM/NEMO/TOP_SRC/FABM/trcwri_fabm.F90
===================================================================
--- /branches/UKMO/AMM15_v3_6_STABLE_package_FABM/NEMOGCM/NEMO/TOP_SRC/FABM/trcwri_fabm.F90	(revision 10156)
+++ /branches/UKMO/AMM15_v3_6_STABLE_package_FABM/NEMOGCM/NEMO/TOP_SRC/FABM/trcwri_fabm.F90	(revision 10156)
@@ -0,0 +1,134 @@
+MODULE trcwri_fabm
+   !!======================================================================
+   !!                       *** MODULE trcwri_fabm ***
+   !!    fabm :   Output of FABM tracers
+   !!======================================================================
+   !! History :   1.0  !  2009-05 (C. Ethe)  Original code
+   !!----------------------------------------------------------------------
+#if defined key_top && key_fabm && defined key_iomput
+   !!----------------------------------------------------------------------
+   !!   'key_fabm'                                           FABM model
+   !!----------------------------------------------------------------------
+   !! trc_wri_fabm   :  outputs of concentration fields
+   !!----------------------------------------------------------------------
+   USE trc         ! passive tracers common variables 
+   USE iom         ! I/O manager
+   USE trdtrc_oce
+   USE trcsms_fabm, only: trc_sms_fabm_check_mass
+   USE par_fabm
+   USE st2d_fabm
+   USE fabm, only: fabm_get_bulk_diagnostic_data, fabm_get_horizontal_diagnostic_data
+
+   IMPLICIT NONE
+   PRIVATE
+
+#if defined key_tracer_budget
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:), SAVE :: tr_temp
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), SAVE :: fabm_st2d_temp
+#endif
+
+   INTERFACE trc_wri_fabm
+       MODULE PROCEDURE wri_fabm,wri_fabm_fl
+   END INTERFACE trc_wri_fabm
+
+
+   PUBLIC trc_wri_fabm 
+
+#  include "top_substitute.h90"
+CONTAINS
+
+   SUBROUTINE wri_fabm_fl(kt,fl)
+      !!---------------------------------------------------------------------
+      !!                     ***  ROUTINE trc_wri_trc  ***
+      !!
+      !! ** Purpose :   output passive tracers fields 
+      !!---------------------------------------------------------------------
+      INTEGER, INTENT( in )               :: fl
+      INTEGER, INTENT( in )               :: kt
+
+#if defined key_tracer_budget
+      INTEGER              :: jn
+      CHARACTER (len=20)   :: cltra
+      REAL(wp), DIMENSION(jpi,jpj,jpk)    :: trpool !temporary storage pool 3D
+      REAL(wp), DIMENSION(jpi,jpj)    :: st2dpool !temporary storage pool 2D
+      !!---------------------------------------------------------------------
+ 
+      ! write the tracer concentrations in the file
+      ! ---------------------------------------
+! depth integrated
+! for strict budgetting write this out at end of timestep as an average between 'now' and 'after' at kt
+      DO jn = 1, jp_fabm1
+        IF(ln_trdtrc (jn))THEN
+         trpool(:,:,:) = 0.5 * ( trn(:,:,:,jp_fabm0+jn-1)*fse3t_a(:,:,:) + &
+                             tr_temp(:,:,:,jn)*fse3t(:,:,:) )
+         cltra = TRIM( model%state_variables(jn)%name )//"_e3t"     ! depth integrated output
+         IF( kt == nittrc000 ) write(6,*)'output pool ',cltra
+         CALL iom_put( cltra, trpool)
+        ENDIF
+      END DO
+#else
+      CONTINUE
+#endif
+
+   END SUBROUTINE wri_fabm_fl
+
+   SUBROUTINE wri_fabm(kt)
+      !!---------------------------------------------------------------------
+      !!                     ***  ROUTINE trc_wri_trc  ***
+      !!
+      !! ** Purpose :   output passive tracers fields 
+      !!---------------------------------------------------------------------
+      INTEGER, INTENT( in )               :: kt
+      INTEGER              :: jn
+
+#if defined key_tracer_budget
+      IF( kt == nittrc000 ) THEN
+         ALLOCATE(tr_temp(jpi,jpj,jpk,jp_fabm),fabm_st2d_temp(jpi,jpj,jp_fabm_surface+jp_fabm_bottom))
+      ENDIF
+      tr_temp(:,:,:,:)=trn(:,:,:,jp_fabm0:jp_fabm1) ! slwa save for tracer budget (unfiltered trn)
+      fabm_st2d_temp(:,:,:)=fabm_st2dn(:,:,:)
+#endif
+      DO jn = 1, jp_fabm
+         CALL iom_put( model%state_variables(jn)%name, trn(:,:,:,jp_fabm0+jn-1) )
+      END DO
+      DO jn = 1, jp_fabm_surface
+         CALL iom_put( model%surface_state_variables(jn)%name, fabm_st2dn(:,:,jn) )
+      END DO
+      DO jn = 1, jp_fabm_bottom
+         CALL iom_put( model%bottom_state_variables(jn)%name, fabm_st2dn(:,:,jp_fabm_surface+jn) )
+      END DO
+
+      ! write 3D diagnostics in the file
+      ! ---------------------------------------
+      DO jn = 1, size(model%diagnostic_variables)
+         IF (model%diagnostic_variables(jn)%save) &
+             CALL iom_put( model%diagnostic_variables(jn)%name, fabm_get_bulk_diagnostic_data(model,jn))
+      END DO
+
+      ! write 2D diagnostics in the file
+      ! ---------------------------------------
+      DO jn = 1, size(model%horizontal_diagnostic_variables)
+         IF (model%horizontal_diagnostic_variables(jn)%save) &
+             CALL iom_put( model%horizontal_diagnostic_variables(jn)%name, fabm_get_horizontal_diagnostic_data(model,jn))
+      END DO
+      !
+      CALL trc_sms_fabm_check_mass
+
+   END SUBROUTINE wri_fabm
+
+#else
+   !!----------------------------------------------------------------------
+   !!  Dummy module :                                     No passive tracer
+   !!----------------------------------------------------------------------
+   PUBLIC trc_wri_fabm
+CONTAINS
+   SUBROUTINE trc_wri_fabm                     ! Empty routine  
+   END SUBROUTINE trc_wri_fabm
+#endif
+
+   !!----------------------------------------------------------------------
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
+   !! $Id: trcwri_fabm.F90 3160 2011-11-20 14:27:18Z cetlod $ 
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !!======================================================================
+END MODULE trcwri_fabm
Index: /branches/UKMO/AMM15_v3_6_STABLE_package_FABM/NEMOGCM/NEMO/TOP_SRC/FABM/vertical_movement_fabm.F90
===================================================================
--- /branches/UKMO/AMM15_v3_6_STABLE_package_FABM/NEMOGCM/NEMO/TOP_SRC/FABM/vertical_movement_fabm.F90	(revision 10156)
+++ /branches/UKMO/AMM15_v3_6_STABLE_package_FABM/NEMOGCM/NEMO/TOP_SRC/FABM/vertical_movement_fabm.F90	(revision 10156)
@@ -0,0 +1,223 @@
+MODULE vertical_movement_fabm
+   !!======================================================================
+   !!                         ***  MODULE vertical_movement_fabm  ***
+   !! TOP :   Module for the vertical movement of the FABM tracers
+   !!======================================================================
+
+#if defined key_fabm
+   !!----------------------------------------------------------------------
+   !!   'key_fabm'                                               FABM tracers
+   !!----------------------------------------------------------------------
+   !! compute_vertical_movement : compute vertical movement of FABM fields
+   !!----------------------------------------------------------------------
+   USE par_trc
+   USE oce_trc
+   USE trc
+   USE par_fabm
+   USE fabm
+   USE dom_oce
+#if defined key_trdtrc && defined key_iomput
+   USE iom
+   USE trdtrc_oce
+#endif
+
+   IMPLICIT NONE
+
+#  include "domzgr_substitute.h90"
+
+   PRIVATE
+
+   PUBLIC compute_vertical_movement
+
+   ! Work arrays for vertical advection (residual movement/sinking/floating)
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, TARGET, DIMENSION(:,:,:) :: w_ct
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, TARGET, DIMENSION(:,:)   :: w_if
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, TARGET, DIMENSION(:,:)   :: zwgt_if
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, TARGET, DIMENSION(:,:)   :: flux_if
+#if defined key_trdtrc && defined key_iomput
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, TARGET, DIMENSION(:,:,:,:) :: tr_vmv
+#endif
+
+   CONTAINS
+
+   SUBROUTINE compute_vertical_movement( kt )
+      !!----------------------------------------------------------------------
+      !!                     ***  compute_vertical_movement  ***
+      !!
+      !! ** Purpose :   compute vertical movement of FABM tracers
+      !!
+      !! ** Method  : Sets additional vertical velocity field and computes
+      !!              resulting advection using a conservative 3rd upwind
+      !!              scheme with QUICKEST TVD limiter, based on GOTM
+      !!              module adv_center.F90 (www.gotm.net). Currently assuming
+      !!              zero flux at sea surface and sea floor.
+      !!----------------------------------------------------------------------
+      !
+      INTEGER, INTENT(in) ::   kt   ! ocean time-step index
+      INTEGER :: ji,jj,jk,jn,k_floor,n_iter,n_count
+      INTEGER,PARAMETER :: n_itermax=100
+      REAL(wp) :: cmax_no,z2dt
+      REAL(wp),DIMENSION(jpk) :: tr_it,tr_u,tr_d,tr_c,tr_slope,c_no,flux_lim
+      REAL(wp),DIMENSION(jpk) :: phi_lim,x_fac
+#if defined key_trdtrc
+      CHARACTER (len=20) :: cltra
+#endif
+
+#if defined key_trdtrc && defined key_iomput
+      IF( lk_trdtrc ) tr_vmv = 0.0_wp
+#endif
+
+      IF( neuler == 0 .AND. kt == nittrc000 ) THEN
+          z2dt = rdt                  ! set time step size (Euler)
+      ELSE
+          z2dt = 2._wp * rdt          ! set time step size (Leapfrog)
+      ENDIF
+      ! Compute interior vertical velocities and include them in source array.
+      DO jj=1,jpj ! j-loop
+         ! Get vertical velocities at layer centres (entire 1:jpi,1:jpk slice).
+         DO jk=1,jpk
+            CALL fabm_get_vertical_movement(model,1,jpi,jj,jk,w_ct(:,jk,:))
+         END DO
+
+         DO ji=1,jpi ! i-loop
+            ! Only process this horizontal point (ji,jj) if number of layers exceeds 1
+            IF (mbkt(ji,jj)>1) THEN ! Level check
+               k_floor=mbkt(ji,jj)
+               ! Linearly interpolate to velocities at the interfaces between layers
+               ! Note:
+               !    - interface k sits between cell centre k and k-1,
+               !    - k [1,jpk] increases downwards
+               !    - upward velocity is positive, downward velocity is negative
+               zwgt_if(1,:)=0._wp ! surface
+               w_if(1,:)=0._wp ! surface
+               zwgt_if(2:k_floor,:)=spread(&
+                   fse3t(ji,jj,2:k_floor)/ (fse3t(ji,jj,1:k_floor-1)+fse3t(ji,jj,2:k_floor))&
+                   ,2,jp_fabm)
+               w_if(2:k_floor,:) = zwgt_if(2:k_floor,:)*w_ct(ji,1:k_floor-1,:)&
+                  +(1._wp-zwgt_if(1:k_floor-1,:))*w_ct(ji,2:k_floor,:)
+               zwgt_if(k_floor+1:,:)=0._wp ! sea floor and below
+               w_if(k_floor+1:,:)=0._wp ! sea floor and below
+
+               ! Advect:
+               DO jn=1,jp_fabm ! State loop
+                  ! get maximum Courant number:
+                  c_no(2:k_floor)=abs(w_if(2:k_floor,jn))*z2dt/ &
+                                ( 0.5_wp*(fse3t(ji,jj,2:k_floor) + &
+                                fse3t(ji,ji,1:k_floor-1)) )
+                  cmax_no=MAXVAL(c_no(2:k_floor))
+
+                  ! number of iterations:
+                  n_iter=min(n_itermax,int(cmax_no)+1)
+                  IF (ln_ctl.AND.(n_iter .gt. 1)) THEN
+                      WRITE(numout,*) 'vertical_movement_fabm():'
+                      WRITE(numout,*) '   Maximum Courant number is ',cmax_no,'.'
+                      WRITE(numout,*) '   ',n_iter,' iterations used for vertical advection.'
+                  ENDIF
+
+                  ! effective Courant number:
+                  c_no=c_no/n_iter
+
+                  tr_it(1:k_floor)=trb(ji,jj,1:k_floor,jp_fabm_m1+jn)
+                  DO n_count=1,n_iter ! Iterative loop
+                     !Compute slope ratio
+                     IF (k_floor.gt.2) THEN !More than 2 vertical wet points
+                        IF (k_floor.gt.3) THEN
+                          WHERE (w_if(3:k_floor-1,jn).ge.0._wp) !upward movement
+                           tr_u(3:k_floor-1)=tr_it(4:k_floor)
+                           tr_c(3:k_floor-1)=tr_it(3:k_floor-1)
+                           tr_d(3:k_floor-1)=tr_it(2:k_floor-2)
+                          ELSEWHERE !downward movement
+                           tr_u(3:k_floor-1)=tr_it(1:k_floor-3)
+                           tr_c(3:k_floor-1)=tr_it(2:k_floor-2)
+                           tr_d(3:k_floor-1)=tr_it(3:k_floor-1)
+                          ENDWHERE
+                        ENDIF
+                        IF (w_if(2,jn).ge.0._wp) THEN
+                           tr_u(2)=tr_it(3)
+                           tr_c(2)=tr_it(2)
+                           tr_d(2)=tr_it(1)
+                        ELSE
+                           tr_u(2)=tr_it(1)
+                           tr_c(2)=tr_it(1)
+                           tr_d(2)=tr_it(2)
+                        ENDIF
+                        IF (w_if(k_floor,jn).ge.0._wp) THEN
+                           tr_u(k_floor)=tr_it(k_floor)
+                           tr_c(k_floor)=tr_it(k_floor)
+                           tr_d(k_floor)=tr_it(k_floor-1)
+                        ELSE
+                           tr_u(k_floor)=tr_it(k_floor-2)
+                           tr_c(k_floor)=tr_it(k_floor-1)
+                           tr_d(k_floor)=tr_it(k_floor)
+                        ENDIF
+                     ELSE !only 2 vertical wet points, i.e. only 1 interface
+                        IF (w_if(k_floor,jn).ge.0._wp) THEN
+                           tr_u(2)=tr_it(2)
+                           tr_c(2)=tr_it(2)
+                           tr_d(2)=tr_it(1)
+                        ELSE
+                           tr_u(2)=tr_it(1)
+                           tr_c(2)=tr_it(1)
+                           tr_d(2)=tr_it(2)
+                        ENDIF
+                     ENDIF
+                     WHERE (abs(tr_d(2:k_floor)-tr_c(2:k_floor)).gt.1.e-10_wp)
+                        tr_slope(2:k_floor)= &
+                           (tr_c(2:k_floor)-tr_u(2:k_floor))/ &
+                           (tr_d(2:k_floor)-tr_c(2:k_floor))
+                     ELSEWHERE
+                        tr_slope(2:k_floor)=SIGN(1._wp,w_if(2:k_floor,jn))* &
+                              (tr_c(2:k_floor)-tr_u(2:k_floor))*1.e10_wp
+                     ENDWHERE
+
+                     !QUICKEST flux limiter:
+                     x_fac(2:k_floor)=(1._wp-2._wp*c_no(2:k_floor))/6._wp
+                     phi_lim(2:k_floor)=(0.5_wp+x_fac(2:k_floor)) + &
+                        (0.5_wp-x_Fac(2:k_floor))*tr_slope(2:k_floor)
+                     flux_lim(2:k_floor)=max( 0._wp, &
+                       min( phi_lim(2:k_floor),2._wp/(1._wp-c_no(2:k_floor)), &
+                         2._wp*tr_slope(2:k_floor)/(c_no(2:k_floor)+1.e-10_wp)) )
+
+                     ! Compute limited flux:
+                     flux_if(2:k_floor,jn) = w_if(2:k_floor,jn)* &
+                        ( tr_c(2:k_floor) + &
+                        0.5_wp*flux_lim(2:k_floor)*(1._wp-c_no(2:k_floor))* &
+                        (tr_d(2:k_floor)-tr_c(2:k_floor)) )
+
+                     ! Compute pseudo update for trend aggregation:
+                     tr_it(1:k_floor-1) = tr_it(1:k_floor-1) + &
+                        z2dt/float(n_iter)/fse3t(ji,jj,1:k_floor-1)* &
+                        flux_if(2:k_floor,jn)
+                     tr_it(2:k_floor) = tr_it(2:k_floor) - &
+                        z2dt/float(n_iter)/fse3t(ji,jj,2:k_floor)* &
+                        flux_if(2:k_floor,jn)
+
+                  ENDDO ! Iterative loop
+
+                  ! Estimate rate of change from pseudo state updates (source
+                  ! splitting):
+                  tra(ji,jj,1:k_floor,jp_fabm_m1+jn) = &
+                     tra(ji,jj,1:k_floor,jp_fabm_m1+jn) + &
+                     (tr_it(1:k_floor) - trb(ji,jj,1:k_floor,jp_fabm_m1+jn))/z2dt
+#if defined key_trdtrc && defined key_iomput
+                  IF( lk_trdtrc .AND. ln_trdtrc( jp_fabm_m1+jn ) ) THEN
+                    tr_vmv(ji,jj,1:k_floor,jn)=(tr_it(1:k_floor) - trb(ji,jj,1:k_floor,jn))/z2dt
+                  END IF
+#endif
+               ENDDO ! State loop
+            END IF ! Level check
+         END DO ! i-loop
+      END DO ! j-loop
+#if defined key_trdtrc && defined key_iomput
+      DO jn=1,jp_fabm ! State loop
+        IF( lk_trdtrc .AND. ln_trdtrc(jp_fabm_m1+jn) ) THEN
+          cltra = 'VMV_'//TRIM(ctrcnm(jp_fabm_m1+jn))
+          CALL iom_put( cltra,  tr_vmv(:,:,:,jn) )
+        END IF
+      ENDDO
+#endif
+
+   END SUBROUTINE compute_vertical_movement
+
+#endif
+END MODULE
Index: /branches/UKMO/AMM15_v3_6_STABLE_package_FABM/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcsms_my_trc.F90
===================================================================
--- /branches/UKMO/AMM15_v3_6_STABLE_package_FABM/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcsms_my_trc.F90	(revision 10155)
+++ /branches/UKMO/AMM15_v3_6_STABLE_package_FABM/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcsms_my_trc.F90	(revision 10156)
@@ -18,4 +18,5 @@
    USE trd_oce
    USE trdtrc
+   USE trcbc, only : trc_bc_read
 
    IMPLICIT NONE
@@ -55,4 +56,6 @@
 
       IF( l_trdtrc )  CALL wrk_alloc( jpi, jpj, jpk, ztrmyt )
+
+      CALL trc_bc_read  ( kt )       ! tracers: surface and lateral Boundary Conditions
 
       IF( l_trdtrc ) THEN      ! Save the trends in the ixed layer
Index: /branches/UKMO/AMM15_v3_6_STABLE_package_FABM/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcwri_my_trc.F90
===================================================================
--- /branches/UKMO/AMM15_v3_6_STABLE_package_FABM/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcwri_my_trc.F90	(revision 10155)
+++ /branches/UKMO/AMM15_v3_6_STABLE_package_FABM/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcwri_my_trc.F90	(revision 10156)
@@ -19,9 +19,17 @@
 
    PUBLIC trc_wri_my_trc 
+#if defined key_tracer_budget
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:), SAVE :: trb_temp ! slwa
+#endif
+
 
 #  include "top_substitute.h90"
 CONTAINS
 
+#if defined key_tracer_budget
+   SUBROUTINE trc_wri_my_trc (kt, fl) ! slwa
+#else
    SUBROUTINE trc_wri_my_trc
+#endif
       !!---------------------------------------------------------------------
       !!                     ***  ROUTINE trc_wri_trc  ***
@@ -29,14 +37,52 @@
       !! ** Purpose :   output passive tracers fields 
       !!---------------------------------------------------------------------
+#if defined key_tracer_budget
+      INTEGER, INTENT( in ), OPTIONAL     :: fl 
+      INTEGER, INTENT( in )               :: kt
+      REAL(wp), DIMENSION(jpi,jpj,jpk)    :: trpool !tracer pool temporary output
+#else
+      INTEGER, INTENT( in )               :: kt
+#endif
       CHARACTER (len=20)   :: cltra
-      INTEGER              :: jn
+      INTEGER              :: jn,jk ! JC TODO jk defined here but may not be used
       !!---------------------------------------------------------------------
  
       ! write the tracer concentrations in the file
       ! ---------------------------------------
+
+
+#if defined key_tracer_budget
+      IF( PRESENT(fl)) THEN
+! depth integrated
+! for strict budgetting write this out at end of timestep as an average between 'now' and 'after' at kt
+         DO jn = jp_myt0, jp_myt1 
+          IF(ln_trdtrc (jn))THEN
+            trpool(:,:,:) = 0.5 * ( trn(:,:,:,jn) * fse3t_a(:,:,:) +  &
+                                        trb_temp(:,:,:,jn) * fse3t(:,:,:) )
+            cltra = TRIM( ctrcnm(jn) )//"e3t"     ! depth integrated output
+            IF( kt == nittrc000 ) write(6,*)'output pool ',cltra
+            DO jk = 1, jpk
+               trpool(:,:,jk) = trpool(:,:,jk)
+            END DO
+            CALL iom_put( cltra, trpool)
+
+          END IF
+         END DO
+
+      ELSE
+
+         IF( kt == nittrc000 ) THEN
+           ALLOCATE(trb_temp(jpi,jpj,jpk,jp_my_trc))  ! slwa
+         ENDIF
+         trb_temp(:,:,:,:)=trn(:,:,:,:) ! slwa save for tracer budget (unfiltered trn)
+
+
+      END IF
+#else
       DO jn = jp_myt0, jp_myt1
          cltra = TRIM( ctrcnm(jn) )                  ! short title for tracer
          CALL iom_put( cltra, trn(:,:,:,jn) )
       END DO
+#endif
       !
    END SUBROUTINE trc_wri_my_trc
@@ -48,5 +94,13 @@
    PUBLIC trc_wri_my_trc
 CONTAINS
-   SUBROUTINE trc_wri_my_trc                     ! Empty routine  
+#if defined key_tracer_budget
+   SUBROUTINE trc_wri_my_trc (kt, fl) ! slwa
+      INTEGER, INTENT( in ), OPTIONAL     :: fl 
+      INTEGER, INTENT( in )               :: kt
+#else
+   ! JC TODO Subroutine arguments (kt) inconsistent with earlier definition
+   SUBROUTINE trc_wri_my_trc (kt)
+      INTEGER, INTENT( in )               :: kt
+#endif
    END SUBROUTINE trc_wri_my_trc
 #endif
Index: /branches/UKMO/AMM15_v3_6_STABLE_package_FABM/NEMOGCM/NEMO/TOP_SRC/TRP/trcldf.F90
===================================================================
--- /branches/UKMO/AMM15_v3_6_STABLE_package_FABM/NEMOGCM/NEMO/TOP_SRC/TRP/trcldf.F90	(revision 10155)
+++ /branches/UKMO/AMM15_v3_6_STABLE_package_FABM/NEMOGCM/NEMO/TOP_SRC/TRP/trcldf.F90	(revision 10156)
@@ -56,5 +56,5 @@
       INTEGER, INTENT( in ) ::   kt   ! ocean time-step index
       !!
-      INTEGER            :: jn
+      INTEGER            :: jn, jk
       CHARACTER (len=22) :: charout
       REAL(wp), POINTER, DIMENSION(:,:,:,:) ::   ztrtrd
@@ -105,4 +105,9 @@
         DO jn = 1, jptra
            ztrtrd(:,:,:,jn) = tra(:,:,:,jn) - ztrtrd(:,:,:,jn)
+#if defined key_tracer_budget
+           DO jk = 1, jpkm1
+             ztrtrd(:,:,jk,jn) = ztrtrd(:,:,jk,jn) * e1t(:,:) * e2t(:,:) * fse3t(:,:,jk)  ! slwa
+           END DO
+#endif
            CALL trd_tra( kt, 'TRC', jn, jptra_ldf, ztrtrd(:,:,:,jn) )
         END DO
Index: /branches/UKMO/AMM15_v3_6_STABLE_package_FABM/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90
===================================================================
--- /branches/UKMO/AMM15_v3_6_STABLE_package_FABM/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90	(revision 10155)
+++ /branches/UKMO/AMM15_v3_6_STABLE_package_FABM/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90	(revision 10156)
@@ -33,4 +33,7 @@
    USE trdtra
    USE tranxt
+   USE trcbdy          ! BDY open boundaries
+   USE bdy_par, only: lk_bdy
+   USE iom
 # if defined key_agrif
    USE agrif_top_interp
@@ -93,4 +96,7 @@
       CHARACTER (len=22) :: charout
       REAL(wp), POINTER, DIMENSION(:,:,:,:) ::  ztrdt 
+#if defined key_tracer_budget
+      REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:,:) ::  ztrdt_m1 ! slwa
+#endif
       !!----------------------------------------------------------------------
       !
@@ -101,4 +107,19 @@
          WRITE(numout,*) 'trc_nxt : time stepping on passive tracers'
       ENDIF
+#if defined key_tracer_budget
+      IF( kt == nittrc000 .AND. l_trdtrc ) THEN
+         ALLOCATE( ztrdt_m1(jpi,jpj,jpk,jptra) )  ! slwa
+         IF( ln_rsttr .AND.    &                     ! Restart: read in restart  file
+            iom_varid( numrtr, 'atf_trend_'//TRIM(ctrcnm(1)), ldstop = .FALSE. ) > 0 ) THEN
+            IF(lwp) WRITE(numout,*) '          nittrc000-nn_dttrc ATF tracer trend read in the restart file'
+            DO jn = 1, jptra
+               CALL iom_get( numrtr, jpdom_autoglo, 'atf_trend_'//TRIM(ctrcnm(jn)), ztrdt_m1(:,:,:,jn) )   ! before tracer trend for atf
+            END DO
+         ELSE          
+           ztrdt_m1=0.0
+         ENDIF
+      ENDIF
+#endif
+
 
 #if defined key_agrif
@@ -111,7 +132,5 @@
 
 
-#if defined key_bdy
-!!      CALL bdy_trc( kt )               ! BDY open boundaries
-#endif
+      IF( lk_bdy )  CALL trc_bdy( kt )               ! BDY open boundaries
 
 
@@ -149,9 +168,37 @@
                zfact = 1.e0 / r2dt(jk)  
                ztrdt(:,:,jk,jn) = ( trb(:,:,jk,jn) - ztrdt(:,:,jk,jn) ) * zfact 
-               CALL trd_tra( kt, 'TRC', jn, jptra_atf, ztrdt )
+!slwa          CALL trd_tra( kt, 'TRC', jn, jptra_atf, ztrdt )
+#if defined key_tracer_budget
+               ztrdt(:,:,jk,jn) = ztrdt(:,:,jk,jn) * e1t(:,:) * e2t(:,:) * e3t_n(:,:,jk)  ! slwa vvl
+               !ztrdt(:,:,jk,jn) = ztrdt(:,:,jk,jn) * e1t(:,:) * e2t(:,:) * e3t_0(:,:,jk)  ! slwa CHANGE for vvl
+#endif
             END DO
+#if defined key_tracer_budget
+! slwa budget code
+              CALL trd_tra( kt, 'TRC', jn, jptra_atf, ztrdt_m1(:,:,:,jn) )
+#else
+              CALL trd_tra( kt, 'TRC', jn, jptra_atf, ztrdt(:,:,:,jn) )
+#endif
          END DO
+#if defined key_tracer_budget
+        ztrdt_m1(:,:,:,:) = ztrdt(:,:,:,:)    ! need previous time step for budget slwa
+#endif
          CALL wrk_dealloc( jpi, jpj, jpk, jptra, ztrdt ) 
       END IF
+
+#if defined key_tracer_budget
+      !                                           Write in the tracer restart file
+      !                                          *******************************
+      IF( lrst_trc ) THEN
+         IF(lwp) WRITE(numout,*)
+         IF(lwp) WRITE(numout,*) 'trc : ATF trend at last time step for tracer budget written in tracer restart file ',   &
+            &                    'at it= ', kt,' date= ', ndastp
+         IF(lwp) WRITE(numout,*) '~~~~'
+         DO jn = 1, jptra
+            CALL iom_rstput( kt, nitrst, numrtw, 'atf_trend_'//TRIM(ctrcnm(jn)), ztrdt_m1(:,:,:,jn) )
+         END DO
+      ENDIF
+#endif
+
       !
       IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
Index: /branches/UKMO/AMM15_v3_6_STABLE_package_FABM/NEMOGCM/NEMO/TOP_SRC/TRP/trcrad.F90
===================================================================
--- /branches/UKMO/AMM15_v3_6_STABLE_package_FABM/NEMOGCM/NEMO/TOP_SRC/TRP/trcrad.F90	(revision 10155)
+++ /branches/UKMO/AMM15_v3_6_STABLE_package_FABM/NEMOGCM/NEMO/TOP_SRC/TRP/trcrad.F90	(revision 10156)
@@ -18,4 +18,7 @@
    USE trdtra
    USE prtctl_trc          ! Print control for debbuging
+#if defined key_tracer_budget
+   USE iom
+#endif
 
    IMPLICIT NONE
@@ -51,4 +54,7 @@
       INTEGER, INTENT( in ) ::   kt   ! ocean time-step index      
       CHARACTER (len=22) :: charout
+      ! +++>>> FABM
+      INTEGER :: jn
+      ! FABM <<<+++
       !!----------------------------------------------------------------------
       !
@@ -65,5 +71,13 @@
       IF( lk_pisces  )   CALL trc_rad_sms( kt, trb, trn, jp_pcs0 , jp_pcs1, cpreserv='Y' )  ! PISCES model
       IF( lk_my_trc  )   CALL trc_rad_sms( kt, trb, trn, jp_myt0 , jp_myt1               )  ! MY_TRC model
-
+      ! +++>>> FABM
+      IF( lk_fabm  )   THEN
+        DO jn=1,jp_fabm ! state variable loop
+          IF (lk_rad_fabm(jn)) THEN
+           CALL trc_rad_sms( kt, trb, trn, jn+jp_fabm_m1 , jn+jp_fabm_m1 )
+          ENDIF
+        END DO
+      END IF
+      ! FABM <<<+++
       !
       IF(ln_ctl) THEN      ! print mean trends (used for debugging)
@@ -110,4 +124,7 @@
       REAL(wp) :: zcoef, ztrcorn, ztrmasn   !    "         "
       REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztrtrdb, ztrtrdn   ! workspace arrays
+#if defined key_tracer_budget
+      REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:,:) ::  ztrtrdb_m1 ! slwa 
+#endif
       REAL(wp) :: zs2rdt
       LOGICAL ::   lldebug = .FALSE.
@@ -116,4 +133,19 @@
  
       IF( l_trdtrc )  CALL wrk_alloc( jpi, jpj, jpk, ztrtrdb, ztrtrdn )
+#if defined key_tracer_budget
+      IF( kt == nittrc000 .AND. l_trdtrc) THEN
+         IF (.not. ALLOCATED(ztrtrdb_m1)) ALLOCATE( ztrtrdb_m1(jpi,jpj,jpk,jptra) )  ! slwa
+            DO jn = jp_sms0, jp_sms1
+               IF( ln_rsttr .AND.    &                     ! Restart: read in restart  file
+                  iom_varid( numrtr, 'rdb_trend_'//TRIM(ctrcnm(jn)), ldstop = .FALSE. ) > 0 ) THEN
+                  IF(lwp) WRITE(numout,*) '          nittrc000-nn_dttrc RDB tracer trend read for',TRIM(ctrcnm(jn))
+                  CALL iom_get( numrtr, jpdom_autoglo, 'rdb_trend_'//TRIM(ctrcnm(jn)), ztrtrdb_m1(:,:,:,jn) )   ! before tracer trend for rdb
+               ELSE
+                  IF(lwp) WRITE(numout,*) '          no nittrc000-nn_dttrc RDB tracer trend for',TRIM(ctrcnm(jn)),', setting to 0.'
+                  ztrtrdb_m1(:,:,:,jn)=0.0
+               ENDIF
+            END DO
+      ENDIF
+#endif
       
       IF( PRESENT( cpreserv )  ) THEN   !  total tracer concentration is preserved 
@@ -156,5 +188,15 @@
                ztrtrdb(:,:,:) = ( ptrb(:,:,:,jn) - ztrtrdb(:,:,:) ) * zs2rdt
                ztrtrdn(:,:,:) = ( ptrn(:,:,:,jn) - ztrtrdn(:,:,:) ) * zs2rdt 
+#if defined key_tracer_budget
+! slwa budget code
+               DO jk = 1, jpkm1
+                  ztrtrdb(:,:,jk) = ztrtrdb(:,:,jk) * e1t(:,:) * e2t(:,:) * fse3t(:,:,jk)
+                  ztrtrdn(:,:,jk) = ztrtrdn(:,:,jk) * e1t(:,:) * e2t(:,:) * fse3t(:,:,jk)
+               END DO
+               CALL trd_tra( kt, 'TRC', jn, jptra_radb, ztrtrdb_m1(:,:,:,jn) )
+               ztrtrdb_m1(:,:,:,jn)=ztrtrdb(:,:,:)
+#else
                CALL trd_tra( kt, 'TRC', jn, jptra_radb, ztrtrdb )       ! Asselin-like trend handling
+#endif
                CALL trd_tra( kt, 'TRC', jn, jptra_radn, ztrtrdn )       ! standard     trend handling
               !
@@ -187,5 +229,15 @@
                ztrtrdb(:,:,:) = ( ptrb(:,:,:,jn) - ztrtrdb(:,:,:) ) * zs2rdt
                ztrtrdn(:,:,:) = ( ptrn(:,:,:,jn) - ztrtrdn(:,:,:) ) * zs2rdt 
+#if defined key_tracer_budget
+! slwa budget code
+               DO jk = 1, jpkm1
+                  ztrtrdb(:,:,jk) = ztrtrdb(:,:,jk) * e1t(:,:) * e2t(:,:) * fse3t(:,:,jk)
+                  ztrtrdn(:,:,jk) = ztrtrdn(:,:,jk) * e1t(:,:) * e2t(:,:) * fse3t(:,:,jk)
+               END DO
+               CALL trd_tra( kt, 'TRC', jn, jptra_radb, ztrtrdb_m1(:,:,:,jn) )
+               ztrtrdb_m1(:,:,:,jn)=ztrtrdb(:,:,:)
+#else
                CALL trd_tra( kt, 'TRC', jn, jptra_radb, ztrtrdb )       ! Asselin-like trend handling
+#endif
                CALL trd_tra( kt, 'TRC', jn, jptra_radn, ztrtrdn )       ! standard     trend handling
               !
@@ -195,4 +247,18 @@
 
       ENDIF
+
+#if defined key_tracer_budget
+      !                                           Write in the tracer restart file
+      !                                          *******************************
+      IF( lrst_trc ) THEN
+         IF(lwp) WRITE(numout,*)
+         IF(lwp) WRITE(numout,*) 'trc : RDB trend at last time step for tracer budget written in tracer restart file ',   &
+            &                    'at it= ', kt,' date= ', ndastp
+         IF(lwp) WRITE(numout,*) '~~~~'
+         DO jn = jp_sms0, jp_sms1
+            CALL iom_rstput( kt, nitrst, numrtw, 'rdb_trend_'//TRIM(ctrcnm(jn)), ztrtrdb_m1(:,:,:,jn) )
+         END DO
+      ENDIF
+#endif
 
       IF( l_trdtrc )  CALL wrk_dealloc( jpi, jpj, jpk, ztrtrdb, ztrtrdn )
Index: /branches/UKMO/AMM15_v3_6_STABLE_package_FABM/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90
===================================================================
--- /branches/UKMO/AMM15_v3_6_STABLE_package_FABM/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90	(revision 10155)
+++ /branches/UKMO/AMM15_v3_6_STABLE_package_FABM/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90	(revision 10156)
@@ -113,4 +113,5 @@
            sbc_trc_b(:,:,:) = 0._wp
          ENDIF
+         sbc_trc(:,:,:) = 0._wp    !slwa initialise for vvl
       ELSE                                         ! Swap of forcing fields
          IF( ln_top_euler ) THEN
